#include "TbiConn.ch"
#include "TbiCode.ch"
/*-----------------------------------------------------------------------------+
 * Programa  * WF_455A    Business Inteligence         * Data   05/05/2000   *
 *-----------------------------------------------------------------------------*
 *Objetivo   * Verificar existncia de estoque para o produto                  *
 *           * (C9_BCLEST="" possui estoque / C9_BLCEST="02" no possui        *
 *           * Se item de producao  - email para PCP solicitando aprovao para*
 *           *                        gerao de O.P.                          * 
 *           * Seno                - criar automaticamente solicitao de com_*
 *           *                        pras, levando em conta LM e LE           *
 *----------------------------------------------------------------------------/*
 * Uso       * WorkFlow/AP5 - Evento Microsiga                                 *
 *-----------------------------------------------------------------------------+
 | Starting  | Ponto de Entrada                                                |
 +-----------------------------------------------------------------------------*/

User Function WF_455A(_nOpcao,oProc)

SetPrvt("oHTML,_lCreditOk,_lEstoq_Ok")
SetPrvt("_cC5_NUM,_cCliente,_aSCSemEst,_aOPSemEst,_lSemCredito")
SetPrvt("_nQtd,_cC1_NUM,_cC1_ITEM,_csubject")
       // wc1_num -> Variavel, armazena o ultimo numero de solicitacao de compra
       // wc1_item-> Variavel, armazena o incremento de sequencia para itens da sc.
       
/*-----------------------------------------------------------------------------*
 * Inicializando rotina                                                        *
 *-----------------------------------------------------------------------------*/

if _nOpcao == Nil

   // Constante
   _cC5_NUM := SC5->C5_NUM
   _nQtd     := 0
   
   amt110cab := {}
   amt110item:= {}
   DBSelectArea("SC6")        // Seleciona Itens do Pedido de Venda
   DBSetOrder(1)      
   //DBSeek( xFilial("SC6") + SC5->C5_NUM )       // SC5->C5_NUM subst. _cC5_NUM
   DBSeek( xFilial("SC6") + _cC5_NUM )       // SC5->C5_NUM subst. _cC5_NUM
   //While !eof() .and. SC6->C6_NUM == SC5->C5_NUM 
   While !SC6->(eof()) .and. SC6->C6_NUM == _cC5_NUM
         ConOut("Verificando Estoque.Item"+SC6->C6_ITEM)
         if !U_CHK_SC9(SC6->C6_NUM,SC6->C6_PRODUTO) // Checar existncia de estoque para o produto
            ConOut("Verificando Producao:"+SC6->C6_PRODUTO)
            if U_CHK_SG1(SC6->C6_PRODUTO, SC6->C6_QTDVEN, .F.)
               ConOut("Gravando Ordem de Produo")
               // Gravar Ordem de Producao
               nprazoestru := prazoestru(SC6->C6_PRODUTO, _nQtd )
               wdataprf    := ddatabase + nprazoestru
               _autoexplode:= "S"         // Autoexplode - indica se op ira explodir calculo para SC
               _cC2_NUM  := GETSX8NUM("SC2","C2_NUM")      // Numero da ultima Solicitacao de Compra
               _aMata650  := {{"C2_NUM"      ,_cC2_NUM           ,NIL},;
                              {"C2_ITEM"     ,"01"               ,NIL},;  // Ricardo
                              {"C2_SEQUEN"   ,"001"              ,NIL},;  // Ricardo 
                              {"C2_PRODUTO"  , SC6->C6_PRODUTO   ,NIL},;
                              {"C2_LOCAL"    , SB1->B1_LOCPAD    ,NIL},;
                              {"C2_QUANT"    , _nQtd             ,NIL},;
                              {"C2_UM"       , SC6->C6_UM        ,NIL},;
                              {"C2_DATPRI"   , DDATABASE         ,NIL},;
                              {"C2_DATPRF"   , wdataprf          ,NIL},;
                              {"C2_PEDIDO"   , SC6->C6_NUM       ,NIL},;
                              {"C2_ITEMPV"   , SC6->C6_ITEM      ,NIL},;                               
                              {"C2_TPOP"     , "P"               ,NIL},;  // Prevista
                              {"AUTEXPLODE"  ,_autoexplode       ,NIL}}

               lmsErroAuto := .F.
               msExecAuto({|x,Y|Mata650(x,Y)},_aMata650,3) // Rotina SIGAAUTO para inclusao de OP
               if lMsErroAuto     // erro durante operacao do SIGAAUTO
                  RollBackSX8()
               else
                  ConfirmSX8()
               endif            

               oProcess:=TWFProcess():New("WF_455A","Emitir Ordem de Produo")
               oProcess:NewTask('Inicio',"\workflow\EVENTO\WF_455A.htm")
               oHtml   := oProcess:oHtml

               montar_op()
            else                        
               ConOut("Gerando Solicitao")
               gerar_sc1()
            endif
         endif  
         SC6->(DBSkip())
   enddo   
   conout("Chegou aqui")
   if !empty(amt110cab)   // if existir solicitacao de compra executar SIGAAUTO
      lmsErroAuto := .F.
      msExecAuto({|X,Y|MATA110(X,Y)},amt110cab,amt110item) 
      if lMsErroAuto      // variavel do sigaauto indicando erro na operacao
         RollBackSX8()
      else
         ConfirmSX8()
      endif
   endif
   
elseif _nOpcao == 1          // Retorno do email de liberao de Ordem de Producao

   _sbm_Aprovado:="Aprovado" // retorno do botao enviar (html)
   
   _rC2_NUM     := oProc:oHtml:RetByName('c2_num')
   _rC2_ITEM    := oProc:oHtml:RetByName('c2_item') 
   _rC2_SEQUEN  := oProc:oHtml:RetByName('c2_sequen')
   _cobs        := oProc:oHtml:RetByName('c2_obs')
   
   // Posiciona Ordem de Produo   
   DBSelectArea("SC2")
   DBSetOrder(1)
   DBSeek( xFilial("SC2") + _rC2_NUM + _rC2_ITEM + _rC2_SEQUEN)   

   //if _wAprovar = "Ordem de Producao Aprovada"
   cONoUT(oProc:oHtml:RetByName("R1"))
   if oProc:oHtml:RetByName("R1") = "Aprovado" 
    
      if Reclock("SC2",.F.)  
         SC2->C2_TPOP := "F"
         SC2->C2_OBS  := _COBS
         MSUNLOCK()         
      endif               

      RastreiaWF("00001"+'.'+oProc:fTaskID,"000001",'1010')                       
   
      DBSelectArea("SC9")    // Seleciona Pedidos Liberados
      DBSetOrder(1)
      DBSeek( xFilial("SC9") + SC2->C2_PEDIDO )
      while !Eof() .and. SC9->C9_PEDIDO = SC2->C2_PEDIDO
 	       if Reclock("SC9",.F.)  
 	          SC9->C9_BLCRED := "  "
 	          SC9->C9_BLEST  := "  " 	          
	          MSUNLOCK()         
            endif
            dbSkip()                                 
      enddo

   else  // Enviar email para vendedor avisando da nao aprovacao para execucao da O.P.

      email := 'vendedor@microsiga'   // email padro
      
      // SC5 -> Pedido de Vendas
      _cC5_VEND1 := RET_CPO("SC5", 1, _cC2_PEDIDO, "C5_VEND1")

      // SA3 -> Vendedores
      _cA3_EMAIL := RET_CPO("SA3", 1, _cC5_VEND1, "A3_EMAIL")

      // Seleciona SA3 - Vendedores
      DbSelectArea("SA3")
      DbSetOrder(1)
      DbSeek( xFilial("SA3") + _cC5_VEND1 )
      email  := if(empty(SA3->A3_EMAIL), email, SA3->A3_EMAIL)
      
      _user := Subs(cUsuario,7,15)

      Reprovar_OP()   // rick
      
   endif
endif

static function gerar_sc1    // Gerar Solicitacao de Compra 
ConOut("Gerar_SC1")
if len(amt110cab) == 0       // iniciar array de cabelhado para SC
   _cC1_NUM  := GETSX8NUM("SC1","C1_NUM")      // Numero da ultima Solicitacao de Compra
   aadd(amt110cab ,{'C1_NUM'       , _cC1_NUM            , nil })
   aadd(amt110cab ,{'C1_EMISSAO'   , DDATABASE            , nil })   
endif  
_cC1_ITEM    := strzero( len(amt110cab) +1, 2) // Incrementar C1_ITEM


aadd(amt110item ,{ {'C1_EMISSAO'   , DDATABASE           , nil } ,;
                   {'C1_ITEM'      , _cC1_ITEM           , nil } ,;
                   {'C1_PRODUTO'   , SC6->C6_PRODUTO     , nil } ,;
                   {'C1_QUANT'     , _nQtd               , nil } ,;
                   {'C1_UM'        , SB1->B1_UM          , nil } ,;
                   {'C1_FORNECE'   , SB1->B1_PROC        , nil }} )
return

//                 {'C1_SOLICIT'   , "Administrador"     , nil } ,;
/*-----------------------------------------------------------------------------+
 * Montar_OP - preparar campo da Ordem de Producao que sera exibido no Html    *
 +-----------------------------------------------------------------------------*/

static function montar_op

       _cC2_PRODUTO := SC6->C6_PRODUTO  // Cdigo do Produto no Pedido de Vendas
       _cC2_NUM     := SC2->C2_NUM
       _cC2_ITEM    := SC2->C2_ITEM
       _cC2_SEQUEN  := SC2->C2_SEQUEN
       _cC2_EMISSAO := DDATABASE        // Data Base para Emisso da OP
       _nC2_QUANT   := _nQtd            // Quantidade a ser fabricada
       _cC2_UM      := SB1->B1_UM       // Unidade de Medida 
       _cC2_DATPRO  := SC2->C2_DATPRI   // Data prevista de Inicio
       _cC2_DATPRF  := SC2->C2_DATPRF   // Data prevista de Entrega
       _cC2_CC      := SB1->B1_CC       // Codigo Centro de Custo
       _cC2_DATAJI  := SC2->C2_DATAJI   // Data ajustada inicial
       _cC2_DataJF  := SC2->C2_DATAJF   // Data ajustada final
       _cC2_STATUS  := SC2->C2_STATUS   // Situao da OP
       //*data inicial real wmatr   := SA1->A1_MATR      // Quantidade de dias de maior atraso
       _cC2_DATRF   := SC2->C2_DATRF    // Data real do fim da OP
       //_cC2_OBS     := SC2->C2_OBS      // Observacoes
      
       aItens  := {} 
       DBSelectArea("SG1")          // Seleciona SG1 - Cadastro de Estruturas
       DbSetOrder(1)
       DBSEEK(XFILIAL("SG1") + _cC2_PRODUTO)
       while !Eof() .and. SG1->G1_COD = _cC2_PRODUTO
             //DBSelectArea("SB1")              // Seleciona Descricao do Produto, order(1)
             SB1->(DBSeek( xFilial("SB1") + SG1->G1_COMP ))
         
             aadd(aItens, { SG1->G1_COMP   ,;   // 1 Componente da estrutura
                            SB1->B1_DESC   ,;   // 2 Descricao do Componente
                            SG1->G1_QUANT  ,;   // 3 Quantidade utilizada
                            SB1->B1_UM     ,;   // 4 Unidade de Medida
                            SG1->G1_NIV    ,;   // 5 Nivel de Empenho
                            SG1->G1_TRT    })   // 6 Sequencia de Producao

             SG1->(DBSkip())
       enddo 

      // SB1 -> Produtos
       _cB1_DESC := RET_CPO("SB1", 1, _cC2_PRODUTO, "B1_DESC")

      // SI3 -> Centro de Custo
       _cI3_DESC := RET_CPO("SI3", 1, SB1->B1_CC, "I3_DESC")

       // SG2 -> Seleciona Operacoes
       _cG2_PRODUTO := RET_CPO("SG2", 1, _cC2_PRODUTO, "G2_PRODUTO")       
       //dBSelectArea("SG2")
       //DbSetOrder(1)
       //DbSeek(xFilial("SG2") + Padr(_cC2_PRODUTO,15))
       //_cG2_PRODUTO := sg2->G2_PRODUTO
       _cG2_RECURSO := SG2->G2_RECURSO
       _cG2_FERRAM  := SG2->G2_FERRAM
       _cG2_OPERAC  := SG2->G2_OPERAC
       _cG2_DESCRI  := SG2->G2_DESCRI
   
       // SH4 -> Ferramentas
       _cH4_DESCRI := RET_CPO("SH4", 1, _cG2_FERRAM, "H4_DESCRI")
   
       // SH1 -> Recursos - Carga Maquina
       _cH1_DESCRI := RET_CPO("SH1", 1, _cG2_RECURSO, "H1_DESCRI")
      
       EnviaEmail()      
return


/*-----------------------------------------------------------------------------+
 * EnviaEmail - Montar email enviando ao destinatario                          *
 +-----------------------------------------------------------------------------*/

Static function EnviaEmail()
       oHtml:ValByName("c2_num"    , _cC2_NUM    )
       oHtml:ValByName("c2_item"   , _cC2_ITEM   )
       oHtml:ValByName("c2_sequen" , _cC2_SEQUEN )    
       oHtml:ValByName("c2_produto", _cC2_PRODUTO)
       oHtml:ValByName("b1_desc"   , _cB1_DESC   )
       oHtml:ValByName("c2_emissao", _cC2_EMISSAO)
       oHtml:ValByName("c2_quant"  , TRANSFORM( _nC2_QUANT ,'@E 9999,999.99' ))
       oHtml:ValByName("c2_um"     , _cC2_UM)
       oHtml:ValByName("d4_op"     , _cC2_NUM + _cC2_ITEM + _cC2_SEQUEN)
       oHtml:ValByName("c2_datpri" , _cC2_DATPRI)
       oHtml:ValByName("c2_datprf" , _cC2_DATPRF)
       oHtml:ValByName("c2_cc"     , _cC2_CC)
       oHtml:ValByName("i3_desc"   , _cI3_DESC)
       oHtml:ValByName("c2_dataji" , _cC2_DATAJI)
       oHtml:ValByName("c2_datajf" , _cC2_DATAJF)
       oHtml:ValByName("c2_status" , _cC2_STATUS)
       oHtml:ValByName("c2_datrf"  , _cC2_DATRF)
//       oHtml:ValByName("c2_obs"    , _cC2_OBS)
       
       For nCount := 1 to Len(aItens)
           aadd(oHtml:ValByName("it.g1_comp")  , aItens[nCount,1])
           aadd(oHtml:ValByName("it.b1_desc")  , aItens[nCount,2])  
           aadd(oHtml:ValByName("it.g1_quant") , TRANSFORM( aItens[nCount,3] ,'@E 9999,999.99' ))
           aadd(oHtml:ValByName("it.b1_um")    , aItens[nCount,4])  
           aadd(oHtml:ValByName("it.g1_niv")   , aItens[nCount,5])  
           aadd(oHtml:ValByName("it.g1_trt")   , aItens[nCount,6])  
           //aadd(oHtml:ValByName("it.local")    , " ")
       Next
       oHtml:ValByName("g2_recurso" , _cG2_RECURSO )
       oHtml:ValByName("h1_descri"  , _cH1_DESCRI  )
       oHtml:ValByName("g2_ferram"  , _cG2_FERRAM  )
       oHtml:ValByName("h4_descri"  , _cH4_DESCRI  )
       oHtml:ValByName("g2_operac"  , _cG2_OPERAC  )
       oHtml:ValByName("g2_descri"  , _cG2_DESCRI  )

       _user := Subs(cUsuario,7,15)
       oProcess:ClientName(_user)
       
       oProcess:cTo      := 'pcp@microsiga' // Definio de e-mail padro
       //oProcess:cCC      := com cpia 
       //oProcess:cBCC     := com cpia oculta
       oProcess:cSubject := "Solicitao de geracao de OP para atender Pedido nmero .: " + SC5->C5_NUM
       //oProcess:cBody  := "Solicitacao para Emissao de O.P. Pedido Numero .: " + _cC5_NUM
       oProcess:bReturn  := "U_WF_455A(1)"
//       oProcess:bTimeOut := { { "U_WF_455A(6)", 1, 0, 2 } }
       //oProcess:CodeTimeOut := { { "FuncaoTimeOut1", ddd, hh, mm } ,;
       //                          { "FuncaoTimeOut2", ddd, hh, mm } }
       oProcess:Start()
       RastreiaWF("00001"+'.'+oProcess:fTaskID,"000001",'1009')	            
       WFSendMail()  // Ricardo       
return

/*-----------------------------------------------------------------------------+
 * Reprovar_OP - Execucao quando PCP rejeitar Ordem de Producao                *
 +-----------------------------------------------------------------------------*/
static function Reprovar_OP()
 
      oProcess:ClientName(_user)              
      cMotivo := oProcess:oHtml:valByName('obs')
      oProcess:Newtask("OP REPROVADA" , "\workflow\EVENTO\opreprovada.htm" )
      oProcess:cTo      := email
      //oProcess:CC     := com cpia 
      //oProcess:BCC    := com cpia oculta
      oProcess:cSubject := "Ordem de Producao no liberada - Pedido " + SC5->C5_NUM
      oHtml:ValByName("PEDIDO"  , SC5->C5_NUM  )                     
      oHtml:ValByName("motivo"  , cMotivo  )                     
      oProcess:Start()    
      WfSendMail()
return

/*-----------------------------------------------------------------------------+
 * Retornar o conteudo do campo, tendo como base os parametros passados        *
 +-----------------------------------------------------------------------------*/
Static function RET_CPO(Arquivo, Indice, Chave, Campo)

DBSelectArea(Arquivo)              // Seleciona Arquivo de Trabalho
DBSetOrder(Indice)
if DBSeek( XFILIAL(Arquivo) + alltrim(Chave) )
   Campo := &(Arquivo+"->"+Campo)
else
   Campo := " "
endif
return(trim(Campo))