#include "rwmake.ch"        // incluido pelo assistente de conversao do AP5 IDE em 20/03/00
 
/*-----------------------------------------------------------------------------+
 * Programa  *EVENTO5.PRW     Marcelo Lopes              Data   23/05/2000  *
 +-----------------------------------------------------------------------------+
 *Objetivo   *Controla a geracao (sched) e aprovacoes dos PC com base na       *
 *           *tabela de aprovadores SCR                                        *
 *-----------------------------------------------------------------------------+
 * Uso       WorkFlow/AP5 Compras Videolar - Pedidos de Compras               *
 *-----------------------------------------------------------------------------+
 | Starting  |                                                                 |
 +-----------------------------------------------------------------------------+

Developer pendings
_cDest (tipo de destinatario)               0 - entrada via ponto de entrada
											1 - retorno de aprovador
											4 - termino R E P R O V A D O 
											5 - termino A P R O V A D O 
											6 - termino T I M E O U T
_nItem (posicao do usuario na cadeia de aprovadores  XX - posio na cadeia)
*/


User Function evento5(_nOpc)

SetPrvt("oHTML,_nOpc")
SetPrvt("CPAR,NBARRA,_nItem,C_MAT,C_DEST")
SetPrvt("C_NUM,C_MOTIVO,_nTotPc,N_TERMINA,_nDoHTML")
SetPrvt("CRAIZ,NRET,NHLDHTM,NHLDSCP,CIND,_cPCAnt")
SetPrvt("_nQtdPc,_nFrtPc,_aItens,LCABEC,_AREGISTROS,NLIMITE")
SetPrvt("CAB_NUM,CAB_EMIS,CAB_FORN,CAB_COND,CAB_NOME,CAB_DESCOND,_NI")
SetPrvt("ARRAYCAB,ARRAYITENS,C_ITPED,NPRESUP,CAPROV,AINFO")
SetPrvt("CMAILAP,CNOMEAP,CORIGEM,CABEC,NHDLVLR,NCOUNT")
SetPrvt("NRESULT,CHTML,NHDLCONNECT,lenvio,lREJEITADO")


//-----------------------------------------------------------------------*
// entrada pelo PONTO DE ENTRADA ou seja inicio de toda operacao         *
//-----------------------------------------------------------------------*

if _nopc == nil 

    lENVIO     := .T.
    lREJEITADO := .F.
	oProcess := TWFProcess():New("evento5")
	oProcess:NewTask('Inicio',"\workflow\evento\EVENTO5.htm")
    oHtml   := oProcess:oHtml
	_nItem := 0
	DBSelectArea("SC7")
	_cPCAnt := "ZZZZZZ"
	_nTotPc := 0
	_nQtdPc := 0
	_nFrtPc := 0
	_nItem  := 0     // soh passa aqui para a geracao inicial de emails	
	_aItens := {}
	lCabec := .f.
	_aRegistros := {}
    aadd(_aRegistros, recno() )
	_cPCAnt := SC7->C7_NUM

//-----------------------------------------------------------------------*
// pega os dados do cabec                                                *
//-----------------------------------------------------------------------*

	if !lCabec
 		lCabec   := .t.
 	    cab_Num  := SC7->C7_Num
    	cab_Emis := DtoC(SC7->C7_Emissao)
   		cab_forn := SC7->C7_Fornece
		Cab_Cond := SC7->C7_Cond
       	DBSelectArea("SA2")
    	DBSeek(xFilial("SA2") + SC7->C7_Fornece + SC7->C7_Loja)
		Cab_Nome := SA2->A2_nReduz
//		DBSelectArea("SE4")
//		DBSEEK(Cab_cond)
//		Cab_descond=SE4->E4_Descri
	endif

	while !eof() .and. SC7->C7_num = _cpcant
    	DBSelectArea("SC7") 
		AADD(_aItens ,{ SC7->C7_ITEM , SC7->C7_PRODUTO , SC7->C7_DESCRI , SC7->C7_QUANT , SC7->C7_UM , SC7->C7_PRECO , SC7->C7_TOTAL , SC7->C7_DATPRF }) 
		_nTotPc := _nTotPc + SC7->C7_Total
		_nQtdPc := _nQtdPc + SC7->C7_Quant
		_nFrtPc := _nFrtPc + SC7->C7_Frete
		dbskip()
	enddo	

//-----------------------------------------------------------------------*
// pega o ultimo elemento                                                *
//-----------------------------------------------------------------------*

 	if _cPCAnt <> "ZZZZZZ" //se o ultimo so tiver 01 item
    	if DefineAp()
    		_nDoHTML := 0
    		MontaHTML()
		else
   			return
		endif    
 	endif
 	
 	dbselectarea("SC7")
 	for _nI := 1 to len(_aregistros)
   		DBGOTO( _aregistros[_nI] )
 		Reclock("SC7",.f.)
		SC7->C7_WF := "1"
		MSUnLock()
	next	 

//-----------------------------------------------------------------------*
//  Reprovacao em qualquer nivel                                         *
//-----------------------------------------------------------------------*

if c_dest == "4" .or. c_dest == "6"// reprovado em qualquer nivel e timeout
	oHtml:LoadFromFile("outro html reprovado por timeout")
    oHtml:Reset()
	DefineOr()
	SolicAp()
	MontaHtml()
	arraycab := {}
	aadd(arraycab,{"C7_NUM",c_Num,NIL})
	arrayitens := {}
	c_itped := "ZZ"	
	dbselectarea("SC7")
	dbsetorder(1)
	dbseek(xfilial("SC7")+c_Num)
	while !eof() .and. SC7->C7_NUM == c_Num  
		c_itped := SC7->C7_item
	    aadd(arrayitens,{{"C7_NUM",c_Num,NIL},{"C7_ITEM",C_ITPED,NIL}} )
		dbskip()
	enddo
    mata120(1,arraycab,arrayitens,5)
 
//-----------------------------------------------------------------------*
//  Outras vezes                                                         *
//-----------------------------------------------------------------------*

else
	nLimite := 0
	if DefineAp()
		if n_termina == 0
//			ATSaldo()
		  	MontaHtml()
		endif
  	else
   		return
	endif
endif
	return
endif

//-----------------------------------------------------------------------*
//  Define Aprovador da Cadeia Completa                                  *
//-----------------------------------------------------------------------*

Static Function DefineAp()
	DbSelectArea("SCR")
    if dbseek(xFilial("SCR")+strzero(_nItem,2))
		cAprov := SCR->CR_User    // Pega o email e o nome do aporvador
		PswOrder(1)
		if PswSeek(cAprov,.t.) .and. cAprov <> "000000"
			aInfo := PswRet(1)
	   	cMailAp := alltrim(aInfo[1,14])
	   	cNomeAP := aInfo[1,2]     // Fim
		endif
	else
		return .f.
	endif
return .t.


//-----------------------------------------------------------------------*
//  Define o solicitante das aprovacoes                                  *
//-----------------------------------------------------------------------*

Static Function SolicAp()
	//define qual o solicitante
	DBSelectArea("SC7")
	DBSeek(xfilial("SC7")+c_num)
	cAprov := SC7->C7_USER
	PswOrder(1)
	if PswSeek(cAprov,.t.)
		aInfo := PswRet(1)
   	cMailAp := alltrim(aInfo[1,14])
	endif
	if cAprov == "000000"
		cMailAp := "mlopes@microsiga"  //Administrador
	endif
return 

//-----------------------------------------------------------------------*
//  Define a Origem do email                                             *
//-----------------------------------------------------------------------*

Static Function DefineOr()
	if _nOpc <> "4"
 		_nItem := _nItem - 1
  	endif
  	DbSelectArea("SCR")
    dbseek(xFilial("SCR")+strzero(_nItem,2))
	cAprov := SCR->CR_User
	PswOrder(1)
	if PswSeek(cAprov,.t.)
		aInfo := PswRet(1)
	  	cOrigem := aInfo[1,2]
	endif
return

//-----------------------------------------------------------------------*
//  Preenche / Monta o html                                              *
//-----------------------------------------------------------------------*

Static Function montahtml()
	if _nDoHTML == 1
	  	DBSelectArea("SC7")
//	  	DBGobot()
	  	cabec := .f.
//		while !eof()
//			if SC7->C7_NUM == c_num 
		while !eof() .and. SC7->C7_NUM == c_Num  
				if !cabec 
					cabec := .t.
					_nTotPc := 0
					_nQtdPc := 0
					_nFrtPc := 0
					_aItens := {}
					cab_Num := c_num
					cab_Emis := DtoC(SC7->C7_Emissao)
					cab_forn := SC7->C7_Fornece
					Cab_Cond := SC7->C7_Cond
					DBSelectArea("SA2")
					DBSeek(xFilial("SA2") + SC7->C7_Fornece + SC7->C7_Loja)
					Cab_Nome := SA2->A2_nReduz
				endif
//				DBSelectArea("SC7") 
//				AADD(_aItens ,{ SC7->C7_ITEM , SC7->C7_PRODUTO , SC7->C7_DESCRI , SC7->C7_QUANT , SC7->C7_UM , SC7->C7_PRECO , SC7->C7_TOTAL , SC7->C7_DATPRF }) 
//	        	_nTotPc := _nTotPc + SC7->C7_Total
//				_nQtdPc := _nQtdPc + SC7->C7_Quant
				_nFrtPc := _nFrtPc + SC7->C7_Frete
//			endif
			DBSkip()
		enddo
	endif  

//-----------------------------------------------------------------------*
//  Preenche os dados do cabealho                                       *
//-----------------------------------------------------------------------*
	
	oHtml:ValByName("C7_Emissao",cab_emis)
	oHtml:ValByName("C7_Fornece",cab_forn)
	oHtml:ValByName("A2_nReduz",cab_nome)
	oHtml:ValByName("c7_cond",cab_cond)
	oHtml:ValByName("C7_Num",cab_num)

//-----------------------------------------------------------------------*
//  Preenche os itens do pedido de compra                                              *
//-----------------------------------------------------------------------*

	For nCount := 1 to Len( _aItens ) 
		aadd(oHtml:ValByName("it.it"), _aItens[nCount,1])
		aadd(oHtml:ValByName("it.cod"), _aItens[nCount,2])
		aadd(oHtml:ValByName("it.desc"), _aItens[nCount,3])
		aadd(oHtml:ValByName("it.qtd"), TRANSFORM( _aItens[nCount,4] ,'@E 999,999,999.99' ))
		aadd(oHtml:ValByName("it.um"), _aItens[nCount,5])
		aadd(oHtml:ValByName("it.prec"), TRANSFORM( _aItens[nCount,6] ,'@E 99,999,999.99' ))
		aadd(oHtml:ValByName("it.tot"), TRANSFORM( _aItens[nCount,7] ,'@E 999,999,999.99' ))  
		aadd(oHtml:ValByName("it.ent"), DTOC(_aItens[nCount,8])) 
	Next 

//-----------------------------------------------------------------------*
//  Preenche os dados do Rodap                                          *
//-----------------------------------------------------------------------*

	oHtml:ValByName("vlipi",TRANSFORM( _nTotPc , '@E 999,999,999.99' ))
	oHtml:ValByName("vlfre",TRANSFORM( _nFrtPc , '@E 9,999,999.99' ))
	oHtml:ValByName("vltot",TRANSFORM( _nTotPc+_nFrtPc , '@E 999,999,999.99' ))
	
/*	if _nOpc == "6"
		oHtml:ValByName("motiv","Demora na resposta do aprovador (TIMEOUT)") 
	endif
	if _nOpc == "4"
		oHtml:ValByName("motiv",cMotivo)
	endif
*/
//-----------------------------------------------------------------------*
//  Start do Workflow                                                    *
//-----------------------------------------------------------------------*
           
	if  lENVIO
    	oProcess:cTo := "mlopes@microsiga"
    	_statapr  := "Segue anexo Pedido para sua Analise e Aprovao"
    elseif lREJEITADO
        oProcess:cto := "mlopes@microsiga"
        _statapr  := "Este pedido no foi aprovado"
    endif
	oProcess:csubject := " Aprovao de Pedido no. " + Cab_Num
	oProcess:cBody := _statapr
	oProcess:Start()
	wfsendmail()
return

static function FuncaoTimeout(oProcess)

return


//-----------------------------------------------------------------------*
//  Libera o pedido como liberador manual no SCR                                                    *
//-----------------------------------------------------------------------*

Static Function Termino()
	dbselectarea("SC7")
	DBSETORDER(1)
	DBSeek(xfilial("SC7")+c_num)
	while !EOF() .and. SC7->C7_Num == c_num
		RecLock("SC7",.f.)
		SC7->C7_ConaPro := "L"
		MsUnLock()
		dbskip()
	enddo
	DefineOr() // para gravar no SRC
   	DBSelectArea("SCR")
	while !eof()
    	If SCR->CR_NUM == c_num
        	RecLock("SCR",.f.)
        	SCR->CR_DataLib := dDataBase
        	SCR->CR_Obs     := "Liberado pelo SIGAWF"
        	SCR->CR_UserLib := cAprov
        	SCR->CR_STATUS  := "03"
        	MsUnLock()
  		endif
  		dbskip()
	enddo
	Return
